↓ Skip to main content
  1. Posts/

hdu 3336 Count the string (nxt函数的运用kmp+(dfs|dp ))

·1306 words·3 mins
Note: This article is available in Chinese only. 本文暂无英文版本。 View original

hdu 3336 题目链接

题意:给一个字符串,问这个字符串的所有前缀的出现次数的和。

思路:这道题需要完全理解 nxt 函数是干嘛的。nxt[i] 表示的是字符串的 0..i-1 位中,前缀和后缀相等的串的最长长度为 nxt[i]。

这东西对于这道题有什么用呢?

举个例子,对于字符串 ababa:

s a b a b a i 0 1 2 3 4 5 next[i] -1 0 0 1 2 3

ans 初始为 len(因为长度为 len 的字符串有 len 个前缀,每个前缀至少出现一次) next[3] = 1,ans + 1 = 6,next[1] = 0 next[4] = 2,ans + 1 = 7,next[2] = 0 next[5] = 3,ans + 1 = 8,next[3] = 1,ans + 1 = 9

首先,我们不是很关心 nxt[i] 具体的值,只关心 nxt[i] 是否大于 0。如果大于 0,比如对于 nxt[3]==1,说明字符串 0..2 位置中,存在一个后缀和前缀相等,因此答案 +1。

其次,其实我们仍然关心 nxt[i] 具体的值,对于 nxt[5]==3,具体对应的含义是有后缀 “aba” 和前缀 “aba” 相等。

但是这就完了吗?因为 nxt[3] 仍然大于 0,对应 “aba” 中有一个前缀 “a” 和后者 “a” 相等。你可能要问:这个不是刚刚算过了吗?然而这里其实算的是字符串 2..4 的 “aba”。

看到有人说这是 dp,不是很懂 dp 做法是什么鬼。

忘记取模 WA 了一发,智力 -2。

代码实现
 1/* ***********************************************
 2Author :111qqz
 3Created Time :2016年08月12日 星期五 12时59分12秒
 4File Name :code/hdu/3336.cpp
 5************************************************ */
 6#include <cstdio>
 7#include <cstring>
 8#include <iostream>
 9#include <algorithm>
10#include <vector>
11#include <queue>
12#include <stack>
13#include <set>
14#include <map>
15#include <string>
16#include <cmath>
17#include <cstdlib>
18#include <deque>
19#include <ctime>
20#define fst first
21#define sec second
22#define lson l,m,rt<<1
23#define rson m+1,r,rt<<1|1
24#define ms(a,x) memset(a,x,sizeof(a))
25typedef long long LL;
26#define pi pair < int ,int >
27#define MP make_pair
28using namespace std;
29const double eps = 1E-8;
30const int dx4[4]={1,0,0,-1};
31const int dy4[4]={0,-1,1,0};
32const int inf = 0x3f3f3f3f;
33const int MOD = 10007;
34const int N=2E5+7;
35int n;
36char s[N];
37int nxt[N];
38int ans;
39void getnxt(char *s)
40{
41    int n = strlen(s);
42    int i = 0 ;
43    int j = -1;
44    nxt[0] = -1;
45    while (i<n)
46    if (j==-1||s[i]==s[j]) nxt[++i]=++j;
47    else j = nxt[j];
48}
49void dfs( int x)
50{
51    if (x<=0) return ;
52    ans = (ans + 1) % MOD;
53    dfs(nxt[x]);
54}
55int main()
56{
57    #ifndef  ONLINE_JUDGE
58    freopen("code/in.txt","r",stdin);
59  #endif
60    int T;
61    scanf("%d",&T);
62    while (T--)
63    {
64        scanf("%d",&n);
65        scanf("%s",s);
66        getnxt(s);
67        int len = strlen(s);
68        ans = len;
69        //for ( int i = 1 ; i <= len ; i++) cout<<"i:"<<i<<" "<<nxt[i]<<endl;
70        for ( int i = 1 ; i <= len ; i++)
71        if (nxt[i]>0) dfs(nxt[i]);//cout<<"ans:"<<ans<<endl;
72        printf("%d\n",ans);
73    }
74  #ifndef ONLINE_JUDGE
75  fclose(stdin);
76  #endif
77    return 0;
78}

下面补一个 dp 做法好了。

dp[i] 表示长度为 i 的前缀出现的次数,显然每个前缀至少出现了一次,所以初始化 dp[i]=1(1<=i<=len)。

转移方程为 dp[nxt[i]] += dp[i]。

这里还是涉及到 nxt 函数的含义。

nxt[i] 表示的是字符串的 0..i-1 位中,前缀和后缀相等的串的最长长度为 nxt[i]。

这就说明,对于长度为 i 的前缀,有一个长度为 nxt[i] 的前缀,出现在了该长度为 i 的前缀的后缀处。

从后往前扫的原因是,对于长度为 i 的前缀,其长度为 nxt[i] 的前缀可能仍然有一个长度为 nxt[nxt[i]] 的前缀。

从后往前可以保证,当从 len 扫描到 i 时,已经将 i+1~len 的贡献累加到 dp[i]。

代码实现
 1/* ***********************************************
 2Author :111qqz
 3Created Time :2016年08月12日 星期五 12时59分12秒
 4File Name :code/hdu/3336.cpp
 5************************************************ */
 6
 7#include <cstdio>
 8#include <cstring>
 9#include <iostream>
10#include <algorithm>
11#include <vector>
12#include <queue>
13#include <stack>
14#include <set>
15#include <map>
16#include <string>
17#include <cmath>
18#include <cstdlib>
19#include <deque>
20#include <ctime>
21#define fst first
22#define sec second
23#define lson l,m,rt<<1
24#define rson m+1,r,rt<<1|1
25#define ms(a,x) memset(a,x,sizeof(a))
26typedef long long LL;
27#define pi pair < int ,int >
28#define MP make_pair
29
30using namespace std;
31const double eps = 1E-8;
32const int dx4[4]={1,0,0,-1};
33const int dy4[4]={0,-1,1,0};
34const int inf = 0x3f3f3f3f;
35const int MOD = 10007;
36const int N=2E5+7;
37int n;
38char s[N];
39int nxt[N];
40int ans;
41void getnxt(char *s)
42{
43    int n = strlen(s);
44    int i = 0 ;
45    int j = -1;
46    nxt[0] = -1;
47    while (i<n)
48    if (j==-1||s[i]==s[j]) nxt[++i]=++j;
49    else j = nxt[j];
50}
51int dp[N];
52int main()
53{
54    #ifndef  ONLINE_JUDGE
55    freopen("./in.txt","r",stdin);
56  #endif
57    int T;
58    scanf("%d",&T);
59    while (T--)
60    {
61        scanf("%d",&n);
62        scanf("%s",s);
63        getnxt(s);
64        int len = strlen(s);
65        for ( int i = 1 ; i <= len ; i++) dp[i] = 1;
66
67        for ( int i = len ; i >= 1 ; i--)
68        {
69        dp[nxt[i]] = (dp[nxt[i]] + dp[i]) % MOD;
70        }
71        int ans = 0 ;
72        for ( int i = 1 ; i <= len ; i++) ans = (ans + dp[i])%MOD;
73        printf("%d\n",ans);
74    }
75
76  #ifndef ONLINE_JUDGE
77  fclose(stdin);
78  #endif
79    return 0;
80}

Related

hdu 2594 Simpsons’ Hidden Talent (kmp)

·310 words·1 min
hdu 2594 题目链接 题意:given string s1,s2, find the longest prefix of s1 that is a suffix of s2. 思路:kmp。。。懒得说了。注意边界。 代码实现 1/* *********************************************** 2Author :111qqz 3Created Time :2016年08月12日 星期五 01时12分51秒 4File Name :code/hdu/2594.cpp 5************************************************ */ 6#include <cstdio> 7#include <cstring> 8#include <iostream> 9#include <algorithm> 10#include <vector> 11#include <queue> 12#include <stack> 13#include <set> 14#include <map> 15#include <string> 16#include <cmath> 17#include <cstdlib> 18#include <deque> 19#include <ctime> 20#define fst first 21#define sec second 22#define lson l,m,rt<<1 23#define rson m+1,r,rt<<1|1 24#define ms(a,x) memset(a,x,sizeof(a)) 25typedef long long LL; 26#define pi pair < int ,int > 27#define MP make_pair 28using namespace std; 29const double eps = 1E-8; 30const int dx4[4]={1,0,0,-1}; 31const int dy4[4]={0,-1,1,0}; 32const int inf = 0x3f3f3f3f; 33const int N=5E5+7; 34char a[N],b[N]; 35int nxt[N]; 36void getnxt( char *s) 37{ 38 int n = strlen(s); 39 int i = 0 ; 40 int j = -1; 41 nxt[0] = -1; 42 while (i<n) 43 if (j==-1||s[i]==s[j]) nxt[++i]=++j; 44 else j = nxt[j]; 45} 46int kmp(char *a,char *b) 47{ 48 int n = strlen(a); 49 int m = strlen(b); 50 getnxt(b); 51 int i = 0; 52 int j = 0; 53 while (i<n) 54 { 55 if (j==-1||a[i]==b[j]) i++,j++; 56 else j = nxt[j]; 57 } 58 if (i==n) return j; 59 return 0; 60} 61int main() 62{ 63 #ifndef ONLINE_JUDGE 64 freopen("code/in.txt","r",stdin); 65 #endif 66 while (~scanf("%s %s",a,b)) 67 { 68// cout<<"a:"<<a<<" b:"<<b<<endl; 69 int k = kmp(b,a); 70 if (k==0) 71 puts("0"); 72 else printf("%s %d\n",b+(strlen(b)-k),k); 73 74 ms(a,0); 75 ms(b,0); 76 } 77 #ifndef ONLINE_JUDGE 78 fclose(stdin); 79 #endif 80 return 0; 81}

hdu 2203 亲和串 (kmp)

·445 words·1 min
hdu 2203 题目链接 题意:给定字符串A(一个环),和字符串B,问B是否在A中出现过。 思路:环的问题。。复制一遍到末尾就好了。。出于严谨的考虑。。我们只复制n-1个字符。 以及要记得判断文本串的长度是否大于等于模板串,如果小于,直接判断no//然而题目数据太水,没判也过了

hdu 3746 Cyclic Nacklace (最小覆盖子串,kmp)

·380 words·1 min
hdu 3746题目链接 题意:给定一个字符串,是一个环(首尾相连),问至少再添加多少个珠子才能使得整个串是循环的。。。 思路:一下子想到了最小覆盖子串的模型。。。我求出最小覆盖子串的长度(n-nxt[n])。然后特判下最小覆盖子串的长度等于字符串长度的情况。。。试着叫了一发。。。竟然就A了2333.。。大概是所谓的题感吧(逃

hdu 5763 || 2016 multi #4 1001 Another Meaning (kmp+dp)

·818 words·2 mins
hdu 5763 题目链接 题意:给定两个字符串A和B,每个出现在A中的B(可以overlap)都有两种含义,问A串一共可能有多少种含义。 思路:kmp+dp. 考虑dp[i]为前i个字符(也就是从开始长度为i,注意不是字符串的下标为i)的含义数。

hdu 1867 A + B for you again (kmp,最短的字符串a+b)

·522 words·2 mins
hdu 1867 题意 题意:给两个字符串,将两个字符串首尾拼接之后得到一个长度最短的字符串,求这个最短的字符串(一个串的前缀可能是另一个串的后缀,这样的话只出现一次就行了) 思路:kmp。。注意和hdu 1841区分。那道题是只要得到一个串包含两个串即可。这道题是首尾拼接得到。